#ifndef FIXORTODAM_H
#define FIXORTODAM_H

#include <stdio.h>
#include "gfunct.h"
#include "iotools.h"
#include "vector.h"

class matrix;

class fixortodam
{
 public:
  fixortodam (void);
  ~fixortodam (void);
  void read (XFILE *in);
  void print (FILE *out);
  void initval(long ipp, long ido);
  void matstiff (matrix &d,long ipp,long ido);
  void tmatstiff (matrix &d,long ipp,long ido);

  void compute_eqdispl(long ipp, matrix &epst, vector &xeq);
  void compute_dam (vector &xeq, vector &omegao, vector &omega);
  void secstiffmat(matrix &d, long ipp, vector &omega);

  void nlstresses (long ipp, long im, long ido);
  void updateval (long ipp,long im,long ido);


  /// tensile stregth in longitudinal direction
  double x1t;

  /// tensile stregth in the first transversal direction
  double x2t;

  /// tensile stregth in the second transversal direction
  double x3t;

  /** equivalent displacement in fully damaged state in longitudinal, the first transversal and the second 
      transversal directions (tension)*/
  vector xeqtf;

  /** equivalent displacement treshold in longitudinal, the first transversal and the second 
      transversal directions (tension)*/
  vector xeqt0;
};

#endif
